MageManaBar = {}

MageManaBar_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
MageManaBar1sec_UpdateInterval = 0.5;

MMBLSM = LibStub("LibSharedMedia-3.0") 

--local MMBmanapoolmultiplier, MMBtempmanapool, MMBmanaoverflow, MMBbloodelfracial, MMBcurrenttime, MMBprevtime, MMBmanaspent, MMBhplost, MMBTimeToOom, MMBTimeToDie, MMBarcaneCD, MMBevocationCD, MMBorbCD, MMBanaGemCD, MMBmanapercent, MMBstep, MMBTagBuild, MMBNewSettings
--	local mana0, manatime0, mmana, manamtime
--	local health0, time0, mhealth, mtime

local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical

function MageManaBar_OnLoad(Frame) 
									
	if select(2, UnitClass("player")) ~= "MAGE" then MageManaBarGlobal:Hide() return end
		
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
	Frame:RegisterEvent("PLAYER_TALENT_UPDATE")
	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Frame:RegisterEvent("UNIT_MAXPOWER")
	Frame:RegisterEvent("UNIT_POWER")
	Frame:RegisterEvent("UNIT_MAXHEALTH")
	Frame:RegisterEvent("UNIT_HEALTH")
	Frame:RegisterEvent("PLAYER_ENTERING_WORLD")
	MMBLSM.RegisterCallback(MageManaBar , "LibSharedMedia_Registered", "SharedMedia_Registered") 
	MMBLSM.RegisterCallback(MageManaBar , "LibSharedMedia_Registered", "SharedMedia_Registered") 
	
	if MMBSettings == nil then 
		MMBreset()
	end
	 
	MMBevocationCDAnim = 0
	MMBmanaGemCDAnim = 0
	MMBArcaneTorrentCDAnim = 0
	MMBOrbCDAnim = 0
	MMBmanaGemFlash = 0
	MMBevocationFlash = 0
	MMBArcaneTorrentFlash = 0
	MMBOrbFlash = 0
	MMBmanaGemresize = 0
	MMBevocationresize = 0
	MMBArcaneTorrentresize = 0
	MMBOrbresize = 0
	MMBPower = 0
	MMBPowerMax = 0
	MMBWastedMana = 0
	MMBTotalWastedMana = 0
	
	MMBLSM:Register("statusbar","CombuBar","Interface\\AddOns\\MageManaBar\\Images\\combubarblack")
	MMBLSM:Register("font","MSBT Bazooka","Interface\\AddOns\\MageManaBar\\Fonts\\Bazooka.ttf")
 
end

-------------------------------
-- helper function for option panel setup
function MMBOptions_OnLoad(panel)
	panel.name = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBInfoOptions_OnLoad(panel)
	panel.name = "Info Panel Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBMarkersOptions_OnLoad(panel)
	panel.name = "Markers Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBHealthOptions_OnLoad(panel)
	panel.name = "Health Bar Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBManaOptions_OnLoad(panel)
	panel.name = "Mana Bar Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBWarningOptions_OnLoad(panel)
	panel.name = "Warning Panel Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

MMBBaseSettings = {
	{"MageManaBarBgFrame",true,true,1,275,40,{0,0,0,1},true,10,1,true,1,true,1,true,true,true},
	-- mana bar frame : frame,enable mana bar,unlock,scale,width,height,color/alpha,background,level,alpha,mana overflow,autohide,markers timers,timer scale, pins colors, enable addon, Wasted mana report
	{"MMBInfoFrame1",true,false,7,83,9,{0.25,0.25,0.3,1},true,2,-2,true,25,false},
	-- TTOOM info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position
	{"MMBInfoFrame2",true,false,7,83,9,{0.25,0.25,0.3,1},true,2,-12,true,26,false},
	-- TTDIE info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position
	{"MMBInfoFrame3",true,false,7,83,9,{0.25,0.25,0.3,1},true,87,-2,true,2,false},
	-- ????? info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position
	{"MMBInfoFrame4",true,false,7,83,9,{0.25,0.25,0.3,1},true,87,-12,true,27,false},
	-- mastery info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position
	{"MMBInfoFrame5",true,false,7,126,9,{0.25,0.25,0.3,1},true,172,-2,true,18,false},
	-- current mana info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position
	{"MMBInfoFrame6",true,false,7,126,9,{0.25,0.25,0.3,1},true,172,-12,true,17,false},
	-- max mana info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position
	{"MMBevocation",true,true,35},
	-- evocation timer : frame, enable, icon/timer, position
	{"MMBmanaGem",true,true,12405},
	-- mana gem timer : frame, enable, icon/timer, position
	{"MMBmageArmor",true,true,103,false},
	-- mage armor timer : frame, enable, icon/timer, position, frost/fire spec
	{"MMBArcaneTorrent",true,true,94},
	-- arcane torrent timer : frame, enable, icon/timer, position
	{"MMBOrb",true,true,80},
	-- arcane torrent timer : frame, enable, icon/timer, position
	{"MageManaBarInfoFrame",true,true,24,_,_,{0,0,0,1}},
	-- info panel : name, enable, background, height, color/alpha
	{"MMBspellcost",true,0.4},
	-- spellcost : name, enable, alpha
	{"MageManaBarFrame",true,{1,0.2,0.2,1},{1,0.4,0,1},{1,0.8,0,1},{1,1,0,1},{0.2,0.5,0.8,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Fonts\\FRIZQT__.TTF", "Friz Quadrata TT", true},
	-- mana bar : name,bar color change, sub evo color, sub flame orb color, sub gem color, sub arcane torrent color, color/alpha, texture, texture name, font, font name, smooth gradient for color change
	{"MageManaBarOverflowFrame",_,_,_,_,_,{1,0.3,0.3,0.5}},
	-- mana bar : name, color/alpha,
	{"MageManaBarWarning",true,false,true,230,20,{0.2,0.5,0.86,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Interface\\AddOns\\MageManaBar\\Fonts\\Bazooka.ttf", "Bazooka",15,true,{0,0,0,1},true,{0.25,0.25,0.3,1},20},
	-- warning bar : name, enable, unlock, autohide, width, height, color/alpha, texture, texture name, fontsize, font, font name, background, background color, text Bg, text Bg color, wait time for burn
	{true,true,true,true,true,true,true,false},
	-- warning bar contents : burn related, mana gem related, evocation related, flame orb related, next burn related, mana overflow related, overflow in fire/frost spec, autohide OOC
	{"MageManaBarHealth",true,true,15,{1,0.3,0.3,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar"},
	-- health bar : name, enable, Bg, height, color, texture, texture name
	{"MageManaBarWarning","MageManaBarHealth","MageManaBarBgFrame","MageManaBarInfoFrame"},
	-- Positionning for frames
}

MMBpositionList = {"Position 1","Position 2","Position 3","Position 4","Hidden"}

MMBpositionDDown = {{"MMBWarningPositionDropDown","MageManaBarWarning"},
				{"MMBHealthPositionDropDown","MageManaBarHealth"},
				{"MMBManaPositionDropDown","MageManaBarBgFrame"},
				{"MMBInfoPositionDropDown","MageManaBarInfoFrame"},}

--------------------------------
-- Helper function for Sharemedia support
function MageManaBar:SharedMedia_Registered()
--	print("prut")
	-- do whatever needs to be done to repaint / refont
end
	
-------------------------------
-- CheckButton function for option panel
function MMBcheckButton(button,row,col)

	if (button:GetChecked() == 1) then 
		(MMBSettings[row])[col] = true 
	elseif (button:GetChecked() == nil) then 
		(MMBSettings[row])[col] = false
	end
	
	MMBFrameResize()
end

function MMBcheckButtonOnload(button,row,col)

	if ((MMBSettings[row])[col] == true) then
		button:SetChecked(true)
	elseif ((MMBSettings[row])[col] == false) then
		button:SetChecked(false)
	end
end

MMBprefixtable = {"evocation","manaGem","ArcaneTorrent","mageArmor","Orb"}

-------------------------------
-- Frame resize function
function MMBFrameResize()

   	MMBFramePosition ()

	-- Settings for Global Frame ----------------------------------------------
	if ((MMBSettings[1])[16] == true) then
		MageManaBarGlobal:Show()
		MageManaBarGlobal:SetWidth((MMBSettings[1])[5])
		MageManaBarGlobal:SetHeight((MMBSettings[1])[6]+(MMBSettings[13])[4]+(MMBSettings[17])[6]+(MMBSettings[19])[4])
		MageManaBarGlobal:EnableMouse((MMBSettings[1])[3])
		MageManaBarGlobal:SetAlpha((MMBSettings[1])[10])
		MageManaBarGlobal:SetFrameLevel((MMBSettings[1])[9])
		MageManaBarGlobal:SetScale((MMBSettings[1])[4])
	else MageManaBarGlobal:Hide()
	end
    
	-- Settings for warning Frame -------------------------------------------------
	if ((MMBSettings[17])[2] == true) then
		MMBFramePositionCallback("MageManaBarWarning",17,"show")
	else MMBFramePositionCallback("MageManaBarWarning",17,"hide")
	end

    MageManaBarWarning:SetHeight((MMBSettings[17])[6])
	MageManaBarWarningBg2:SetHeight((MMBSettings[17])[6]-3)
	MageManaBarWarningBar:SetHeight((MMBSettings[17])[6]-3)
	MageManaBarWarning:SetWidth((MMBSettings[17])[5])
	MageManaBarWarningBg2:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningBar:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningText:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningBar:SetStatusBarColor(unpack((MMBSettings[17])[7]))
	MageManaBarWarningBar:SetStatusBarTexture((MMBSettings[17])[8])
	MageManaBarWarningBg:SetVertexColor(unpack((MMBSettings[17])[14]))
	MageManaBarWarningBg2:SetVertexColor(unpack((MMBSettings[17])[16]))
	MageManaBarWarningText:SetFont((MMBSettings[17])[10],(MMBSettings[17])[12])
    
	if ((MMBSettings[17])[13] == true) then 
		MageManaBarWarningBg:Show()
	else MageManaBarWarningBg:Hide()
	end
    
	if ((MMBSettings[17])[15] == true) then 
		MageManaBarWarningBg2:Show()
	else MageManaBarWarningBg2:Hide()
	end

	-- Settings for Health bar  -------------------------------------------------
	if ((MMBSettings[19])[2] == true) then
		MMBFramePositionCallback("MageManaBarHealth",19,"show")
	else MMBFramePositionCallback("MageManaBarHealth",19,"hide")
	end
    
	MageManaBarHealth:SetHeight((MMBSettings[19])[4])
	MageManaBarHealthBg2:SetHeight((MMBSettings[19])[4]-2)
	MageManaBarHealth:SetWidth((MMBSettings[1])[5])
	MageManaBarHealthBg2:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarHealthBar:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarHealthBar:SetHeight((MMBSettings[19])[4]-2)
	MageManaBarHealthBar:SetStatusBarColor(unpack((MMBSettings[19])[5]))
	MageManaBarHealthBar:SetStatusBarTexture((MMBSettings[19])[6])
	if ((MMBSettings[1])[8] == true) then 
		MageManaBarHealthBg:Show()
		MageManaBarHealthBg2:Show()
		MageManaBarHealthBg:SetVertexColor(unpack((MMBSettings[1])[7]))
	else MageManaBarHealthBg:Hide()
		MageManaBarHealthBg2:Hide()
	end
		
	-- Settings for Mana frame -----------------------------------------
	if ((MMBSettings[1])[2] == true) then
		MMBFramePositionCallback("MageManaBarBgFrame",1,"show")
	else MMBFramePositionCallback("MageManaBarBgFrame",1,"hide")
	end
    
	MageManaBarBgFrame:SetWidth((MMBSettings[1])[5])
	MageManaBarBgFrameBg2:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarBgFrame:SetHeight((MMBSettings[1])[6])
	MageManaBarBgFrameBg2:SetHeight((MMBSettings[1])[6]-2)
	MageManaBarBgFrameTexture:SetVertexColor(unpack((MMBSettings[1])[7]))
	if ((MMBSettings[1])[8] == true) then
		MageManaBarBgFrameTexture:Show()
		MageManaBarBgFrameBg2:Show()
	else MageManaBarBgFrameTexture:Hide()
		MageManaBarBgFrameBg2:Hide()
	end

	MageManaBarOverflowFrame:SetStatusBarColor(unpack((MMBSettings[16])[7]))
	MageManaBarOverflowFrame:SetStatusBarTexture((MMBSettings[15])[8])
	MageManaBarOverflowFrame:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarOverflowFrame:SetHeight((MMBSettings[1])[6]-2)
	
	MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[7]))
	MageManaBarFrame:SetStatusBarTexture((MMBSettings[15])[8])
	MageManaBarFrame:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarFrame:SetHeight((MMBSettings[1])[6]-2)
	
	-- settings for info frames ------------------------------------------------
	for i = 2,7 do
		_G[(MMBSettings[i])[1].."Text"]:SetFont((MMBSettings[15])[10],(MMBSettings[i])[4])
		_G[(MMBSettings[i])[1]]:EnableMouse((MMBSettings[i])[3]);
		_G[(MMBSettings[i])[1]]:SetWidth((MMBSettings[i])[5]);
		_G[(MMBSettings[i])[1]]:SetHeight((MMBSettings[i])[6]);
		_G[(MMBSettings[i])[1].."Texture"]:SetVertexColor(unpack((MMBSettings[i])[7]))
		if ((MMBSettings[i])[8] == true) then
			_G[(MMBSettings[i])[1].."Texture"]:Show()
		else _G[(MMBSettings[i])[1].."Texture"]:Hide()
		end
		if ((MMBSettings[i])[2] == true) then
			_G[(MMBSettings[i])[1]]:Show()
		else _G[(MMBSettings[i])[1]]:Hide()
		end
	end
	
	if ((MMBSettings[13])[3] == true) then 
        MageManaBarInfoFrameTexture:Show()
	else MageManaBarInfoFrameTexture:Hide()
	end
	
	if ((MMBSettings[13])[2] == true) then
		MMBFramePositionCallback("MageManaBarInfoFrame",13,"show")
	else MMBFramePositionCallback("MageManaBarInfoFrame",13,"hide")
	end

	MageManaBarInfoFrameTexture:SetVertexColor(unpack((MMBSettings[13])[7]))
	MageManaBarInfoFrame:SetHeight((MMBSettings[13])[4])
	MageManaBarInfoFrame:SetWidth((MMBSettings[1])[5])
	
	-- settings for mana markers icons --------------------------------------------
	for i = 8,12 do 
	if ((MMBSettings[i])[2] == true) then
		_G[(MMBSettings[i])[1]]:Show()
	else _G[(MMBSettings[i])[1]]:Hide()
		end
	if ((MMBSettings[i])[3] == true) then
		_G[(MMBSettings[i])[1].."Icon"]:Show()
		_G[(MMBSettings[i])[1].."Frame"]:Show()
		if _G[(MMBSettings[i])[1].."Text"] then
			_G[(MMBSettings[i])[1].."Text"]:Show()
		end
	else _G[(MMBSettings[i])[1].."Icon"]:Hide()
		 _G[(MMBSettings[i])[1].."Frame"]:Hide()
		 if _G[(MMBSettings[i])[1].."Text"] then
			_G[(MMBSettings[i])[1].."Text"]:Hide()
		 end
	end
	end

	if ((MMBSettings[1])[13] == true) then 
	MMBmanaGemTextFrame:Show()
	MMBevocationTextFrame:Show()
	MMBArcaneTorrentTextFrame:Show()
	MMBOrbTextFrame:Show()
	else MMBmanaGemTextFrame:Hide()
		MMBevocationTextFrame:Hide()
		MMBArcaneTorrentTextFrame:Hide()
		MMBOrbTextFrame:Hide()
	end

	for i = 1,#MMBprefixtable do -- adjust height of markers gradients
		
		_G["MMB"..MMBprefixtable[i]]:SetHeight((MMBSettings[1])[6]-2)
		_G["MMB"..MMBprefixtable[i].."gradred"]:SetHeight((MMBSettings[1])[6]-2)
		_G["MMB"..MMBprefixtable[i].."gradblack"]:SetHeight((MMBSettings[1])[6]-2)
		_G["MMB"..MMBprefixtable[i].."gradFrame"]:SetHeight((MMBSettings[1])[6]-2)
	end
	
	-- Settings for expected spell mana cost ---------------------------------------
	if ((MMBSettings[14])[2] == true) then
        MMBspellcost:Show()
		MMBspellcost:SetHeight((MMBSettings[1])[6]-2)
		MMBspellcost:SetAlpha((MMBSettings[14])[3])
	else MMBspellcost:Hide()
	end
	
	-- Added functions -------------------------------------------------------------
	MMBManabarMaxPool()
	MMBmageArmorSpec()
	MMBAutohide()
	MMBmagearmorupdate()
	MMBInfoFramesResize()

end

-------------------------------
-- Color picker function
function MMBColorPicker(button,row,col)

	MMBpickercol = col
	MMBpickerrow = row
	MMBpickerbutton = button
	ColorPickerFrame:SetColorRGB(((MMBSettings[row])[col])[1],((MMBSettings[row])[col])[2],((MMBSettings[row])[col])[3]);
	ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (((MMBSettings[row])[col])[4] ~= nil), ((MMBSettings[row])[col])[4];
	ColorPickerFrame.previousValues = {((MMBSettings[row])[col])[1],((MMBSettings[row])[col])[2],((MMBSettings[row])[col])[3],((MMBSettings[row])[col])[4]};
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = MMBCallback, MMBCallback, MMBCallback;
	ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
	ColorPickerFrame:Show();

end

function MMBCallback (restore)

	local newR, newG, newB, newA;
	
	if restore then
		newR, newG, newB, newA = unpack(restore);
	else newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB()
	end
	
	((MMBSettings[MMBpickerrow])[MMBpickercol])[1],((MMBSettings[MMBpickerrow])[MMBpickercol])[2],((MMBSettings[MMBpickerrow])[MMBpickercol])[3],((MMBSettings[MMBpickerrow])[MMBpickercol])[4] = newR, newG, newB, newA
	_G[MMBpickerbutton:GetName().."SwatchTexture"]:SetVertexColor(unpack((MMBSettings[MMBpickerrow])[MMBpickercol]))
	MMBFrameResize()
	
end

-------------------------------
-- Reset savedvariables function
function MMBreset()
	
	MMBSettings = {}
	for i = 1,#MMBBaseSettings do
		MMBSettings[i] = {}
		for z = 1,#MMBBaseSettings[i] do
		if type((MMBBaseSettings[i])[z]) == "table" then
			(MMBSettings[i])[z] = {}
			for x = 1,#(MMBBaseSettings[i])[z] do
				((MMBSettings[i])[z])[x] = ((MMBBaseSettings[i])[z])[x]
			end
		else (MMBSettings[i])[z] = (MMBBaseSettings[i])[z]
		end
		end
	end
	
	if (select(2, UnitRace("player")) == "BloodElf") then
		(MMBSettings[11])[2] = true
	else (MMBSettings[11])[2] = false
	end 
	
	MageManaBarGlobal:ClearAllPoints() 
	MageManaBarGlobal:SetPoint("CENTER",UIParent,"CENTER",0,0)
	
	print("MageManaBar settings have been reset.")

end

function MMBNewSettingsCheck()

	MMBNewSettings = 0
	
	for i = 1,#MMBBaseSettings do
	
		if MMBSettings[i] == nil then
			MMBSettings[i] = {}
		end
 
		for z = 1,#MMBBaseSettings[i] do
		
			if type((MMBBaseSettings[i])[z]) == "table" and (MMBSettings[i])[z] == nil then

				(MMBSettings[i])[z] = {}

				for x = 1,#(MMBBaseSettings[i])[z] do
				
					((MMBSettings[i])[z])[x] = ((MMBBaseSettings[i])[z])[x]
					MMBNewSettings = MMBNewSettings + 0.25
				end
			
			elseif (MMBSettings[i])[z] == _ then
				
				(MMBSettings[i])[z] = (MMBBaseSettings[i])[z]
				
			elseif type((MMBSettings[i])[z]) ~= type((MMBBaseSettings[i])[z]) then
  
                if i == 20 and MMBSettings[i] ~= nil then
                else (MMBSettings[i])[z] = (MMBBaseSettings[i])[z]
                    MMBNewSettings = MMBNewSettings + 1
 --                   print(i,z);   
                end
            end
		end
		
	end
	
end

function MMBInfoFramesResize()

	local MMBinfowidth = ((MMBSettings[1])[5]-4)/7
	local MMBinfoheight = ((MMBSettings[13])[4]-3)/2

	for i = 1,6 do
    
        if (MMBSettings[i+1])[13] == false then
        
			if (i < 5) then
                (MMBSettings[i+1])[9] = MMBinfowidth*2
			else (MMBSettings[i+1])[9] = MMBinfowidth*3
			end
            
            (MMBSettings[i+1])[10] = MMBinfoheight
            
			_G["MMBInfoFrame"..i]:SetHeight(MMBinfoheight);
			_G["MMBInfoFrame"..i]:SetWidth((MMBSettings[i+1])[9]);
            
			if (i == 1) or (i == 3) or (i == 5) then
				MMBcoordH = 1
			else MMBcoordH = 2 + MMBinfoheight
			end
			
			MMBcoordW = ceil(i/2) + ((ceil(i/2)-1) * (MMBinfowidth*2)) 
            
			_G["MMBInfoFrame"..i]:ClearAllPoints()
			_G["MMBInfoFrame"..i]:SetPoint("TOPLEFT", MageManaBarInfoFrame, "TOPLEFT", MMBcoordW, 0-MMBcoordH)
            _G["MMBInfoFrame"..i]:SetParent(MageManaBarInfoFrame)
        else _G["MMBInfoFrame"..i]:ClearAllPoints()
            _G["MMBInfoFrame"..i]:SetPoint("TOPLEFT",MageManaBarGlobal,"TOPLEFT",(MMBSettings[i+1])[9],(MMBSettings[i+1])[10])
            _G["MMBInfoFrame"..i]:SetParent(MageManaBarGlobal)
        end
		
        _G["MMBInfoFrame"..i]:SetFrameLevel(MageManaBarGlobal:GetFrameLevel()+7)

    end
end

function MMBInfoFrameReset(...)

	for i = 1,select("#", ...) do
		for z = 1,#MMBBaseSettings[select(i, ...)] do
			if type((MMBBaseSettings[select(i, ...)])[z]) == "table" then
				for x = 1,#(MMBBaseSettings[select(i, ...)])[z] do
					((MMBSettings[select(i, ...)])[z])[x] = ((MMBBaseSettings[select(i, ...)])[z])[x]
				end
			else (MMBSettings[select(i, ...)])[z] = (MMBBaseSettings[select(i, ...)])[z]
			end
		end
		if _G[(MMBSettings[select(i, ...)])[1]] and _G[(MMBSettings[select(i, ...)])[1]]:IsUserPlaced() then
			_G[(MMBSettings[select(i, ...)])[1]]:SetUserPlaced(nil)
		end
	end

	MMBFrameResize()
	InterfaceOptionsFrame:Hide()
	InterfaceOptionsFrame:Show()
	
end

function MMBInfoCoords(frame,var)

	(MMBSettings[var])[9] = (frame:GetLeft() - MageManaBarGlobal:GetLeft());
	(MMBSettings[var])[10] = (frame:GetTop() - MageManaBarGlobal:GetTop());
	_G[frame:GetName().."Xvalue"]:SetText(format("%.0f",(MMBSettings[var])[9]))
	_G[frame:GetName().."Yvalue"]:SetText(format("%.0f",(MMBSettings[var])[10]))
   
end

function MMBmanaInfoUpdate()
	
	for i = 2,7 do
	
		local text = MMBInfoFunction[(MMBSettings[i])[12]]()
		
 		if text then
			if (MMBSettings[i])[11] == true then 
				_G["MMBInfoFrame"..(i-1).."Text"]:SetText(MMBInfoFunctionPrefix[(MMBSettings[i])[12]]..text)
			else _G["MMBInfoFrame"..(i-1).."Text"]:SetText(text)
			end
		end
	end

end

function MMBAutohide()

	if ((MMBSettings[1])[12] == 1) and ((MMBSettings[1])[16] == true) then
		MageManaBarGlobal:Show()
	elseif ((MMBSettings[1])[12] == 2) then
		if UnitAffectingCombat("player") and ((MMBSettings[1])[16] == true) then
			MageManaBarGlobal:Show()
		else MageManaBarGlobal:Hide()
		end
	elseif ((MMBSettings[1])[12] == 3) then
		if (GetPrimaryTalentTree() == 1) and ((MMBSettings[1])[16] == true) then
			MageManaBarGlobal:Show()
		else MageManaBarGlobal:Hide()
		end
	elseif ((MMBSettings[1])[12] == 4) then
		if UnitAffectingCombat("player") and (GetPrimaryTalentTree() == 1) and ((MMBSettings[1])[16] == true) then
			MageManaBarGlobal:Show()
		else MageManaBarGlobal:Hide()
		end
	end
	
end

function MMBSpellcastManaCost()

	if UnitCastingInfo("player") then
		MMBcurrentSpellcost = select(4,GetSpellInfo(select(1,UnitCastingInfo("player"))))
	else MMBcurrentSpellcost = nil
	end
	
	if (MMBcurrentSpellcost ~= nil) then
		MMBspellcost:Show()
		MMBspellcost:ClearAllPoints()
		MMBspellcost:SetPoint("TOPRIGHT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+1,0)
		MMBspellcost:SetWidth((MageManaBarOverflowFrame:GetWidth()*(MMBcurrentSpellcost/UnitPowerMax("player")))+1)
	else MMBspellcost:Hide()
	end
end

function MMBManabarUpdate()

    if ((MMBSettings[1])[11] == true) then
		MageManaBarOverflowFrame:SetValue(UnitPower("player"))
	end

	if UnitIsDeadOrGhost("player") then 
        MageManaBarFrame:SetValue(0)
        MageManaBarOverflowFrame:SetValue(0)
    else MageManaBarFrame:SetValue(UnitPower("player"))
	end
    
end

function MMBManabarMaxPool()

	MMBmanapoolmultiplier = 1.05
	MMBtempmanapool = 0

	for i = 1,40 do
	
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", i)
		
		if (spellId == 79060) or (spellId == 79061) or (spellId == 79062) or (spellId == 79063) or (spellId == 90363) or (spellId == 79833)  then
			MMBmanapoolmultiplier = MMBmanapoolmultiplier*1.05
		elseif (spellId == 69378) then
			MMBmanapoolmultiplier = MMBmanapoolmultiplier*1.04
		elseif spellId then
			for z = 1,#MMBbufflist do
				if (spellId == (MMBbufflist[z])[2]) then
					MMBtempmanapool = MMBtempmanapool + (MMBbufflist[z])[3]
				table.insert(MMBcurrentbuff,{expirationTime,name,duration,(MMBbufflist[z])[3]})
					break
				end
			end	
		else break
		end
	end
	
	if (#MMBcurrentbuff ~= 0) then
	
		for i = #MMBcurrentbuff,1,-1 do
			
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", (MMBcurrentbuff[i])[2])
			if (name == nil) then
			table.remove(MMBcurrentbuff,i)
			end
		end
	end
	
	MMBtempmanapool = (MMBtempmanapool * MMBmanapoolmultiplier)
	MMBregmanapool = UnitPowerMax("player")-MMBtempmanapool
	MageManaBarFrame:SetMinMaxValues(0,MMBregmanapool)
	MageManaBarOverflowFrame:SetWidth(MageManaBarFrame:GetWidth() * (UnitPowerMax("player")/MMBregmanapool ))
	MageManaBarOverflowFrame:SetMinMaxValues(0,UnitPowerMax("player"))
	
	MMBmanaGem:ClearAllPoints()
	MMBmanaGem:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((MMBSettings[9])[4]/MMBregmanapool)),0)
	MMBevocation:ClearAllPoints()
	MMBevocation:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[8])[4])/100)),0)
	MMBArcaneTorrent:ClearAllPoints()
	MMBArcaneTorrent:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[11])[4])/100)),0)
	MMBOrb:ClearAllPoints()
	MMBOrb:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[12])[4])/100)),0)
	MMBOrb:ClearAllPoints()
	MMBOrb:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[12])[4])/100)),0)

end

function MMBwarning()

	if select(2,GetSpellCooldown(12042)) > 1.6 then MMBarcaneCD = select(2,GetSpellCooldown(12042))-(GetTime()-select(1,GetSpellCooldown(12042)))
	else MMBarcaneCD = 0
	end
	
	if select(2,GetSpellCooldown(12051)) > 1.6 then MMBevocationCD = select(2,GetSpellCooldown(12051))-(GetTime()-select(1,GetSpellCooldown(12051)))
	else MMBevocationCD = 0
	end
	
	if select(2,GetSpellCooldown(5405)) > 1.6 then MMBmanaGemCD = select(2,GetSpellCooldown(5405))-(GetTime()-select(1,GetSpellCooldown(5405)))
	else MMBmanaGemCD = 0
	end
	
	if select(2,GetSpellCooldown(82731)) > 1.6 then MMBorbCD = select(2,GetSpellCooldown(82731))-(GetTime()-select(1,GetSpellCooldown(82731)))
	else MMBorbCD = 0
	end
	
	MMBmanapercent = (UnitPower("player")/MMBregmanapool)*100
	local text
	local MMBEvoWait = (MMBSettings[17])[17]
	local MMBEvoBurn = (select(2,GetSpellCooldown(12042))-MMBEvoWait)
    MMBoverflow = 0
		
	if (UnitPower("player") > (UnitPowerMax("player")-MMBtempmanapool)) and ((MMBSettings[18])[6] == true) then -- warning when mana overflow
	
		for i = #MMBcurrentbuff,1,-1 do
		
			MMBmanaoverflow = (UnitPower("player")-(UnitPowerMax("player")-MMBtempmanapool))
			MMBbuffoverflowtimer = (MMBcurrentbuff[i])[1]-GetTime()
			
			if (MMBmanaoverflow > 0) then
					text = format("|cffff0000OVERFLOW : %s / %.1fs|r", MMBNumberConvert(MMBmanaoverflow), MMBbuffoverflowtimer)
				MageManaBarWarningBar:SetMinMaxValues(0,(MMBcurrentbuff[i])[3])
				MageManaBarWarningBar:SetValue(MMBbuffoverflowtimer)
				break
			elseif ((MMBcurrentbuff[i])[4] <= MMBmanaoverflow) then
				MMBmanaoverflow = MMBmanaoverflow - (MMBcurrentbuff[i])[4]
			end
		end
		
		MMBoverflow = 1
	
	elseif (GetPrimaryTalentTree() == 1) then
    
        if UnitAffectingCombat("player") then
		
            if UnitAura("player", select(1,GetSpellInfo(12051))) and ((MMBSettings[18])[3] == true) then -- warning for evocation running
                text = format("|cffffffffEvocating...|r")
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBarcaneCD > 75) and (MMBmanaGemCD == 0) and (GetItemCount(36799, false,true) ~= 0) and ((MMBSettings[18])[2] == true) then -- warning for mana gem use when AP running
                text = format("|cffffffffBurning, use gem now !!|r")
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBorbCD == 0) and (MMBevocationCD > MMBEvoWait) and (MMBmanapercent < (MMBSettings[12])[4]) and ((MMBSettings[18])[4] == true) then -- warning for orb regen phase
                text = format("|cffffffff%.0f%% mana reached, use Orb now !!|r", (MMBSettings[12])[4])
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBorbCD == 0) and (MMBevocationCD > MMBEvoWait) and ((MMBSettings[18])[4] == true) then -- warning for orb burn phase
                text = format("|cffffffffOrb phase, mana at %.1f%%|r", MMBmanapercent)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBorbCD > 45) and (MMBevocationCD > MMBEvoWait) and ((MMBSettings[18])[4] == true) then -- warning for orb AM Spam phase
                text = format("|cffffffffAM spam, next burn in %.1f|r", MMBevocationCD-MMBEvoWait)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBarcaneCD == 0) and (MMBevocationCD <= MMBEvoWait) and ((MMBSettings[18])[1] == true) then -- warning when burn phase is ready
                text = format("|cffffffffBurn phase ready...|r")
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBevocationCD == 0) and (MMBmanapercent < (MMBSettings[8])[4]) and ((MMBSettings[18])[3] == true) then -- warning when evocation mark reached
                text = format("|cffffffff%.0f%% mana reached, Evocate now !!|r",(MMBSettings[8])[4])
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBevocationCD > MMBEvoWait) and (MMBarcaneCD+MMBEvoWait < MMBevocationCD) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
                text = format("|cffffffffNext burn phase in %.1f|r", MMBevocationCD-MMBEvoWait)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBarcaneCD > 0) and (MMBevocationCD < MMBEvoWait) and ((MMBSettings[18])[1] == true) then -- warning for burn phase
                text = format("|cffffffffBurning, mana at %.1f%%|r", MMBmanapercent)
                MageManaBarWarningBar:SetValue(0)
            else text = ""
                MageManaBarWarningBar:SetValue(0)
            end
        
        elseif (MMBarcaneCD == 0) and (MMBevocationCD <= MMBEvoWait) and ((MMBSettings[18])[1] == true) then -- warning when burn phase is ready
                text = format("|cffffffffBurn phase ready...|r")
                MageManaBarWarningBar:SetValue(0)
        elseif (MMBevocationCD > MMBEvoWait) and (MMBevocationCD-MMBEvoWait > MMBarcaneCD) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
                text = format("|cffffffffNext burn phase in %.1f|r", MMBevocationCD-MMBEvoWait)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
--~         elseif (MMBmanaGemCD > 0) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
--~                 text = format("|cffffffffNext burn phase in %.1f|r", MMBmanaGemCD)
--~                 MageManaBarWarningBar:SetMinMaxValues(0,select(2,GetSpellCooldown(5405)))
--~                 MageManaBarWarningBar:SetValue(MMBmanaGemCD)
        elseif (MMBarcaneCD > 0) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
                text = format("|cffffffffNext burn phase in %.1f|r", MMBarcaneCD)
                MageManaBarWarningBar:SetMinMaxValues(0,select(2,GetSpellCooldown(12042)))
                MageManaBarWarningBar:SetValue(MMBarcaneCD)
        else text = ""
            MageManaBarWarningBar:SetValue(0)
        end
            
		
	else text = ""
		MageManaBarWarningBar:SetValue(0)
	end

	if (text == "") and ((MMBSettings[17])[4] == true) then
		MageManaBarWarning:Hide()
	elseif (MMBSettings[18])[8] == true and not UnitAffectingCombat("player") then
		MageManaBarWarning:Hide()
	elseif ((MMBSettings[17])[2] == true) then
		MageManaBarWarning:Show()
	end 
	
	MageManaBarWarningText:SetText(text)
	
	if MMBoverflow == 1 then
		MageManaBarWarningBar:SetStatusBarColor(1,0.5,0.8,0.5)
	else MageManaBarWarningBar:SetStatusBarColor(unpack((MMBSettings[17])[7]))
	end

end

function MMBmanabarcolorchange()

	if MMBmanapercent then
		if (MMBmanapercent < (MMBSettings[8])[4]) and (MMBSettings[8])[2] == true then -- evocation mark
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[3]))
		elseif (MMBmanapercent < (MMBSettings[12])[4]) and (MMBSettings[12])[2] == true then -- flame orb mark
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[4]))
		elseif (UnitPower("player") < (MMBregmanapool - (MMBSettings[9])[4])) and (MMBSettings[9])[2] == true then -- mana gem mark
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[5]))
		elseif (MMBmanapercent < (MMBSettings[11])[4]) and (MMBSettings[11])[2] == true then -- arcane torrent
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[6]))
		else MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[7])) -- full mana color
		end
	end

end

function MMBSpellTimer(prefix,spellId)

	local start, duration, enable = GetSpellCooldown(spellId)
		
	if (duration > 1.55) and (_G["MMB"..prefix.."CDAnim"] == 0) then
		_G["MMB"..prefix.."Cooldown"]:SetCooldown(start,duration)
		_G["MMB"..prefix.."CDAnim"] = 1
	elseif (duration == 0) and (_G["MMB"..prefix.."CDAnim"] == 1) then
		_G["MMB"..prefix.."gradCooldown"]:SetCooldown(0,0)
		_G["MMB"..prefix.."CDAnim"] = 0
	end
	
	if (duration > 1.55) and (MMBSettings[1])[13] == true then
	
		MMBspellCD = tonumber(format("%.0f",duration-(GetTime()-start)))
		
		local filename, fontHeight, flags = _G["MMB"..prefix.."Timer"]:GetFont()
		local MMBfontscale = (MMBSettings[1])[14]
		
		if (MMBspellCD < 10) then
		
		if (_G["MMB"..prefix.."Flash"] < 3) then
			_G["MMB"..prefix.."Timer"]:SetText(format("|cffff0000%.0f|r",MMBspellCD))
			_G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
		elseif (_G["MMB"..prefix.."Flash"] < 6) then
			_G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
			_G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
		else  _G["MMB"..prefix.."Flash"] = 1
		end
		
		if (_G["MMB"..prefix.."resize"] == 2) then 
			_G["MMB"..prefix.."Timer"]:SetFont(filename,13.3*MMBfontscale, flags) 
			_G["MMB"..prefix.."resize"] = 0
		end

		elseif (MMBspellCD < 60) then
		
		_G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
		
		if (_G["MMB"..prefix.."resize"] == 1) then 
			_G["MMB"..prefix.."Timer"]:SetFont(filename,9.8*MMBfontscale, flags) 
			_G["MMB"..prefix.."resize"] = 2
		end
		
		elseif (MMBspellCD >= 60) then
		
		_G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%d:%0.2d|r",MMBspellCD / 60, MMBspellCD % 60))
		
		if (_G["MMB"..prefix.."resize"] == 0) then 
			_G["MMB"..prefix.."Timer"]:SetFont(filename,7.5*MMBfontscale, flags) 
			_G["MMB"..prefix.."resize"] = 1
		end
		end
		
		_G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
		
	else _G["MMB"..prefix.."Timer"]:SetText("")
	end
	
	if ((MMBSettings[1])[15] == true) and (duration < 1.55) then
		_G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,1,0.2,0.8,0.2,0)
	else _G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
	end

	if (spellId == 5405) and (GetItemCount(36799, false,true) == 0) then
		MMBmanaGemIcon:SetVertexColor(1,0,0,1)
        if ((MMBSettings[1])[15] == true) and (duration < 1.55) then
            MMBmanaGemgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
        end
	elseif (spellId == 5405) and (GetItemCount(36799, false,true) ~= 0) then
		MMBmanaGemIcon:SetVertexColor(1,1,1,1)
    end
	
end

function MMBmageArmorSpec()

	if (GetPrimaryTalentTree() ~= 1) and ((MMBSettings[10])[5] == false) then
		MMBmageArmor:Hide()
	elseif (GetPrimaryTalentTree() == 1) and ((MMBSettings[10])[2] == true) then
		MMBmageArmor:Show()
	elseif ((MMBSettings[10])[5] == true) and ((MMBSettings[10])[2] == true) then
		MMBmageArmor:Show()
	end
	
end        

function MMBmagearmorupdate()

	MMBmageArmor:ClearAllPoints()
	if (MMBmageArmorIcon:GetTexture() == "Interface\\Icons\\Spell_Frost_FrostArmor02") then
		MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", ceil((MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+(MageManaBarOverflowFrame:GetWidth()*((102/100)-1))),0)
	else MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", ceil((MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+(MageManaBarOverflowFrame:GetWidth()*(((MMBSettings[10])[4]/100)-1))),0)
	end

end

function MMBMageArmorType()

	if select(1,UnitAura("player",select(1,GetSpellInfo(7302)))) then
		if (select(4,GetGlyphSocketInfo(1)) == 98397) or (select(4,GetGlyphSocketInfo(4)) == 98397) or (select(4,GetGlyphSocketInfo(6)) == 98397) then 
            MMBmageArmorIcon:SetVertexColor(1,1,1,1)
            MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_Frost_FrostArmor02")
            MMBmagearmorupdate()
            if ((MMBSettings[1])[15] == true) then
                MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,0,0.2,0.8,0.2,1)
            else MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
            end
        else MMBmageArmorIcon:SetVertexColor(1,0,0,1)
            MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
            MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
		end
	elseif select(1,UnitAura("player",select(1,GetSpellInfo(6117)))) then
		MMBmageArmorIcon:SetVertexColor(1,1,1,1)
        MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
        if ((MMBSettings[1])[15] == true) then
            MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,0,0.2,0.8,0.2,1)
        else MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
		end
	else MMBmageArmorIcon:SetVertexColor(1,0,0,1)
        MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
        MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
	end

end

function MMBCreateTextureList(frame,row,col,colourcol)

	MMBTextureList = {} for k in pairs(MMBLSM:HashTable("statusbar")) do tinsert(MMBTextureList,{k,MMBLSM:HashTable("statusbar")[k]}) end
	
	MMBTextureBorderFrame:Show()
	MMBTextureBorderFrame:ClearAllPoints()
	MMBTextureFrame:SetHeight(#MMBTextureList*20)
	MMBTextureBorderFrame:SetPoint("CENTER",frame,"CENTER",0,0-(MMBTextureBorderFrame:GetHeight()/4))
	MMBTextureBorderFrame:SetParent(InterfaceOptionsFrame)
	MMBTextureBorderFrame:SetFrameLevel(_G[frame:GetName().."Button"]:GetFrameLevel()+1)
	MMBTextureBorderFrame:SetScale(1.3)
	MMBTextureRow = row
	MMBTextureCol = col
	MMBTextureDDown = frame
	
	for i = 1,#MMBTextureList do
		
		if not _G["MMBTexture"..i] then
			CreateFrame("button", "MMBTexture"..i, MMBTextureFrame, "MMBTextureTemplate")
		end
		
		if i == 1 then
			MMBTexture1:ClearAllPoints()
			MMBTexture1:SetPoint("TOP",MMBTextureFrame,"TOP",0,0)
		else _G["MMBTexture"..i]:ClearAllPoints()
			_G["MMBTexture"..i]:SetPoint("TOP",_G["MMBTexture"..i-1],"BOTTOM",0,0)
		end
		
		_G["MMBTexture"..i.."Bar"]:SetTexture((MMBTextureList[i])[2])
		_G["MMBTexture"..i.."Bar"]:SetVertexColor(unpack((MMBSettings[row])[colourcol]))
		_G["MMBTexture"..i.."Text"]:SetText((MMBTextureList[i])[1])
		
		if (MMBTextureList[i])[1] == (MMBSettings[row])[col+1] then
			_G["MMBTexture"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
		else _G["MMBTexture"..i.."Text"]:SetTextColor(1,1,1,1)
		end
	
	end
	
end
		
function MMBCreateFontList(frame,row,col,colourcol)

	MMBFontList = {} for k in pairs(MMBLSM:HashTable("font")) do tinsert(MMBFontList,{k,MMBLSM:HashTable("font")[k]}) end
	
	MMBFontBorderFrame:Show()
	MMBFontBorderFrame:ClearAllPoints()
	MMBFontFrame:SetHeight(#MMBFontList*15)
	MMBFontBorderFrame:SetPoint("CENTER",frame,"CENTER",0,0-(MMBFontBorderFrame:GetHeight()/4))
	MMBFontBorderFrame:SetParent(InterfaceOptionsFrame)
	MMBFontBorderFrame:SetFrameLevel(_G[frame:GetName().."Button"]:GetFrameLevel()+1)
	MMBFontBorderFrame:SetScale(1.3)
	MMBFontRow = row
	MMBFontCol = col
	MMBFontDDown = frame
	
	for i = 1,#MMBFontList do
	
		if not _G["MMBFont"..i] then
			CreateFrame("button", "MMBFont"..i, MMBFontFrame, "MMBFontTemplate")
		end
		
		if i == 1 then
		MMBFont1:ClearAllPoints()
		MMBFont1:SetPoint("TOP",MMBFontFrame,"TOP",0,0)
		else _G["MMBFont"..i]:ClearAllPoints()
			_G["MMBFont"..i]:SetPoint("TOP",_G["MMBFont"..i-1],"BOTTOM",0,0)
		end
		
		_G["MMBFont"..i.."Bar"]:SetTexture((MMBSettings[row])[col-2])
		_G["MMBFont"..i.."Bar"]:SetVertexColor(unpack((MMBSettings[row])[colourcol]))
		_G["MMBFont"..i.."Text"]:SetText((MMBFontList[i])[1])
		_G["MMBFont"..i.."Text"]:SetFont((MMBFontList[i])[2],9)
		
		if (MMBFontList[i])[1] == (MMBSettings[row])[col+1] then
			_G["MMBFont"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
		else _G["MMBFont"..i.."Text"]:SetTextColor(1,1,1,1)
		end
	
	end
	
end

function MMBNumberConvert(value)

   if value > 999 then
      return format("%.1fk", value / 1000)
   else return value
   end

end

function MMBInfoTag()

	MMBInfoTagFrame:Show()
	MMBInfoTagFrame:SetScale(1.2)
    MMBInfoTagFrame:SetFrameStrata("HIGH")
	MMBInfoTagFrame:SetFrameLevel(_G["MMBTagSetup"..(MMBTagRow-1)]:GetFrameLevel()+1)
	MMBInfoTagFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)

	if not MMBTagButton1 then
	
		for i = 1, #MMBInfoFunction do
			CreateFrame("button", "MMBTagButton"..i, MMBInfoTagFrame, "MMBInfoTagButtonTemplate")

			_G["MMBTagButton"..i]:SetID(i)
			
			if i == 1 then
				_G["MMBTagButton"..i]:ClearAllPoints()

				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",MMBInfoTagFrame,"TOPLEFT",5,-5)
				MMBTagBuild = 0

			elseif type(MMBInfoFunction[i-1]) == "string" then

				_G["MMBTagButton"..i]:ClearAllPoints()

				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",_G["MMBTagButton"..i-1],"BOTTOMLEFT",0,-5)
				MMBTagBuild = 1

			elseif MMBTagBuild == 3 then
				_G["MMBTagButton"..i]:ClearAllPoints()
				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",_G["MMBTagButton"..i-3],"BOTTOMLEFT",0,-5)
				MMBTagBuild = 1
			elseif MMBTagBuild == 1 or MMBTagBuild == 2 then
				_G["MMBTagButton"..i]:ClearAllPoints()

				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",_G["MMBTagButton"..i-1],"TOPRIGHT",5,0)

				MMBTagBuild = MMBTagBuild + 1
			end

		end
	end
	
	for i = 1, #MMBInfoFunction do
		if type(MMBInfoFunction[i]) == "string" then
			_G["MMBTagButton"..i.."Value"]:SetText("")
			_G["MMBTagButton"..i.."Text"]:SetWidth(200)
			_G["MMBTagButton"..i.."Text"]:SetText(MMBInfoFunction[i])
			_G["MMBTagButton"..i.."Text"]:SetFont("Fonts\\FRIZQT__.TTF",10)

			_G["MMBTagButton"..i.."Text"]:SetJustifyH("LEFT")
			_G["MMBTagButton"..i.."Text"]:SetJustifyV("BOTTOM")
			_G["MMBTagButton"..i.."Bg"]:Hide()
			_G["MMBTagButton"..i]:EnableMouse(false)
		elseif (MMBInfoFunction[i]) == 0 then
			_G["MMBTagButton"..i]:Hide()
			_G["MMBTagButton"..i]:EnableMouse(false)
		else _G["MMBTagButton"..i.."Text"]:SetText(MMBInfoFunctionText[i])
			_G["MMBTagButton"..i.."Value"]:SetText(MMBInfoFunction[i]())

			_G["MMBTagButton"..i.."Value"]:SetFont((MMBSettings[15])[10],9)
			_G["MMBTagButton"..i.."Value"]:SetJustifyH("CENTER")

			_G["MMBTagButton"..i.."Value"]:SetJustifyV("MIDDLE")

			_G["MMBTagButton"..i.."Bg"]:Show()
		end

	end

end
		
MMBInfoFunction = { "Health related",

					function() if UnitIsDead("player") then	return "Dead" elseif UnitIsGhost("player") then	return "Ghost" end return MMBNumberConvert(UnitHealth("player")) end, -- Current Health
		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" end return UnitHealth("player") end, -- Absolute Current HP
		    		function() return MMBNumberConvert(UnitHealthMax("player")) end, -- Max HP

		    		function() return UnitHealthMax("player") end, -- Absolute Max HP

		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" end return format("%s/%s", MMBNumberConvert(UnitHealth("player")), MMBNumberConvert(UnitHealthMax("player"))) end, --Cur/Max HP
		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" end return format("%s/%s", UnitHealth("player"), UnitHealthMax("player")) end, -- Absolute Cur/Max HP

		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" elseif (UnitHealthMax("player") - UnitHealth("player")) <= 0 then return "--" else return MMBNumberConvert(UnitHealthMax("player") - UnitHealth("player")) end end, -- Missing HP

		    		function() if UnitHealthMax("player") <= 0 or UnitIsDead("player") or UnitIsGhost("player") then return "0%" end return format("%.1f%%",UnitHealth("player") / UnitHealthMax("player") * 100) end, -- Percent Hp

		    		0,

		    		
		    		"Mana related",

		    		function() if UnitIsDeadOrGhost("player") then return 0 end return MMBNumberConvert(UnitPower("player")) end, -- Current Power
		    		function() if UnitIsDeadOrGhost("player") then return 0 end	return UnitPower("player") end, -- Absolute Current power

		    		function() return MMBNumberConvert(UnitPowerMax("player")) end, -- Max power

		    		function() return UnitPowerMax("player") end, -- Absolute max power
		    		function() return format("%s/%s", MMBNumberConvert(UnitPower("player")), MMBNumberConvert(UnitPowerMax("player"))) end, -- Cur/Max Power

		    		function() return format("%s/%.1f%%", MMBNumberConvert(UnitPower("player")), UnitPower("player") / MMBregmanapool * 100) end, -- Cur/% Power

		    		function() return format("%s/%s", MMBNumberConvert(MMBregmanapool), MMBNumberConvert(UnitPowerMax("player"))) end, -- regular Max power/Max Power

		    		function() return format("%s/%s", UnitPower("player"), UnitPowerMax("player")) end, -- Absolute Cur/Max power

		    		function() if (UnitPowerMax("player") - UnitPower("player")) > 0 then return MMBNumberConvert(UnitPowerMax("player") - UnitPower("player")) else return "--" end end, -- Missing power
		    		function() if UnitIsDeadOrGhost("player") then return "0%" end return format("%.1f%%", UnitPower("player") / MMBregmanapool * 100) end, -- Percent power
	
		    		0,

		    		0,
		    		
		    		"Miscellanous",
		    		function() return MMBTimeToOom() end,

		    		function() return MMBTimeToDie(UnitName("target")) end,
		    		function() if (GetPrimaryTalentTree() == 1) then return format("+%.1f%%", (1.5 * GetMastery()) * (UnitPower("player")/UnitPowerMax("player"))) elseif (GetPrimaryTalentTree() == 2) then return format("+%.1f%%", 2.8 * GetMastery()) elseif (GetPrimaryTalentTree() == 3) then return format("+%.1f%%", 2.5 * GetMastery()) end end,
                    function() if (GetPrimaryTalentTree() == 1) then return GetSpellBonusDamage(7) elseif (GetPrimaryTalentTree() == 2) then return GetSpellBonusDamage(3) elseif (GetPrimaryTalentTree() == 3) then return GetSpellBonusDamage(5) end end,
                    } 

MMBInfoFunctionText = {	"",

						"Current HP",
						"Absolute Current HP",
						"Max HP",
						"Absolute Max HP",
						"Cur/Max HP",
						"Absolute Cur/Max HP",
						"Missing HP",
						"Percent HP",

						0,

						
						"",
						"Current mana",
						"Absolute Current mana",
						"Max mana",
						"Absolute Max mana",
						"Cur/Max mana",
						"Cur/Percent mana",
						"Reg Max mana/Max mana",
						"Absolute Cur/Max mana",
						"Missing mana",
						"Percent mana",

						0,

						0,
						
						"",
						"Time To OOM",

						"Time To Die",

						"Mastery",
                        "Spellpower",
}

MMBInfoFunctionPrefix = {	"",

							"Curr HP : ",
							"Curr HP : ",
							"Max HP : ",
							"Max HP : ",
							"Cur/Max HP : ",
							"Cur/Max HP : ",
							"Miss HP : ",
							"% HP : ",

							0,

							
							"",
							"Curr mana : ",
							"Curr mana : ",
							"Max mana : ",
							"Max mana : ",
							"Cur/Max mana : ",
							"Cur/% mana : ",
							"Max mana : ",
							"Cur/Max mana : ",
							"Miss mana : ",
							"% mana : ",

							0,

							0,
							
							"",
							"TTOOM : ",

							"TTDie : ",

							"Mastery : ",
                            "Sp : ",

}

function MMBTimeToDie(unit) 

	local MMBhealth = UnitHealth("target")
	
	if MMBoldhealth ~= MMBhealth then

		MMBoldhealth = MMBhealth

		local text
		
		if MMBhealth == UnitHealthMax("target") then
			MMBhealth0, MMBtime0, MMBmhealth, MMBmtime = nil
			text = "--"
			return text
		end
	
		local MMBtime = GetTime()
	
		if not MMBhealth0 then
			MMBhealth0, MMBtime0 = MMBhealth, MMBtime
			MMBmhealth, MMBmtime = MMBhealth, MMBtime
			return
		end
	
		MMBmhealth = (MMBmhealth + MMBhealth) * .5
		MMBmtime = (MMBmtime + MMBtime) * .5
	
		if MMBmhealth >= MMBhealth0 then
			MMBhealth0, MMBtime0, MMBmhealth, MMBmtime = nil
			text = "Healing"
		else  
			MMBTimeToDIE = MMBhealth * (MMBtime0 - MMBmtime) / (MMBmhealth - MMBhealth0)
			if (MMBTimeToDIE <= 60) then
				text = format("%0.2d",MMBTimeToDIE)
			elseif (MMBTimeToDIE > 60) then
				text = format("%d:%0.2d",MMBTimeToDIE / 60, MMBTimeToDIE % 60)
			end
		end

		return text
		
	elseif unit == nil then
		
		return "--"
		
	end
	
end

function MMBTimeToOom() 

	local MMBmana = UnitPower("player")
	
	if MMBoldmana ~= MMBmana then
		
		MMBoldmana = MMBmana

		local text
		
		if MMBmana == UnitPowerMax("player") then
			MMBmana0, MMBmanatime0, MMBmmana, MMBmanamtime = nil
			text = "--"
			return text
		end
	
		local MMBmanatime = GetTime()
	
		if not MMBmana0 then
			MMBmana0, MMBmanatime0 = MMBmana, MMBmanatime
			MMBmmana, MMBmanamtime = MMBmana, MMBmanatime
			return
		end
	
		MMBmmana = (MMBmmana + MMBmana) * .5
		MMBmanamtime = (MMBmanamtime + MMBmanatime) * .5
	
		if MMBmmana > MMBmana0 then
			MMBmana0, MMBmanatime0, MMBmmana, MMBmanamtime = nil
			text = "Regen"
		else  
			MMBTimeToOOM = MMBmana * (MMBmanatime0 - MMBmanamtime) / (MMBmmana - MMBmana0)
			if (MMBTimeToOOM <= 60) then
			text = format("%0.2d",MMBTimeToOOM)
			elseif (MMBTimeToOOM > 60) then
			text = format("%d:%0.2d",MMBTimeToOOM / 60, MMBTimeToOOM % 60)
			end
		end
		
		return text 
		
	end

end

function MMBFramePositionCallback (frame, row, method)

	local MMBframeposition = 0
	
	for i = 1, #MMBSettings[20] do
	
		if (MMBSettings[20])[i] == frame then
			MMBframeposition =  1
			break
		else MMBframeposition = 0
		end

	end
	
	if method == "hide" and MMBframeposition == 1 then
		MMBFramePosition (frame,5,row)
	elseif method == "show" and MMBframeposition == 0 then
		MMBFramePosition (frame,#MMBSettings[20]+1,row)	
	end
	
end
	
function MMBFramePosition (frame,position,row)

	for i = 1, #MMBSettings[20] do -- this part clean the frame list by removing the called frame from it
		
		if (MMBSettings[20])[i] == frame and frame then
			table.remove(MMBSettings[20],i)
			break
		end
	end
	
	if position ~= 5 and position then -- this part insert the called frame in the list at the needed position and callback the enable settings in Savedvariable table
		(MMBSettings[row])[2] = true
		--_G[(MMBSettings[row])[1]]:Show()
		if position > #MMBSettings[20] then 
			table.insert(MMBSettings[20],#MMBSettings[20]+1,frame)
		else table.insert(MMBSettings[20],position,frame)
		end
	elseif position == 5 then
		(MMBSettings[row])[2] = false
	--	_G[(MMBSettings[row])[1]]:Hide()
	end
	
	for i = 1, #MMBpositionDDown do -- this part actualize the dropdowns and hide/show the frame
	
		for x = 1, #MMBSettings[20] do
		
			if (MMBpositionDDown[i])[2] == (MMBSettings[20])[x] then
				UIDropDownMenu_SetSelectedID(_G[(MMBpositionDDown[i])[1]], x)
				UIDropDownMenu_SetText(_G[(MMBpositionDDown[i])[1]], MMBpositionList[x])
				_G[(MMBpositionDDown[i])[2]]:Show()
				break
			else UIDropDownMenu_SetSelectedID(_G[(MMBpositionDDown[i])[1]], 5)
				UIDropDownMenu_SetText(_G[(MMBpositionDDown[i])[1]], MMBpositionList[5])
				_G[(MMBpositionDDown[i])[2]]:Hide()
			end
		end
	end
	
	if #MMBSettings[20] > 1 then -- this part redo all the positionning depending on the new frame list
			
		for i = 1, #MMBSettings[20] do
			
			if i == 1 then
				_G[(MMBSettings[20])[i]]:ClearAllPoints()
				_G[(MMBSettings[20])[i]]:SetPoint("TOP", MageManaBarGlobal, "TOP", 0,0)
			else _G[(MMBSettings[20])[i]]:ClearAllPoints()
				_G[(MMBSettings[20])[i]]:SetPoint("TOP", _G[(MMBSettings[20])[i-1]], "BOTTOM", 0,0)
			end
		end
	end
	
end
	
function MMBhealthUpdate()

	MageManaBarHealthBar:SetMinMaxValues(0,UnitHealthMax("player"))
	if UnitIsDeadOrGhost("player") then 
        MageManaBarHealthBar:SetValue(0)
    else MageManaBarHealthBar:SetValue(UnitHealth("player"))
    end
    
end

function MMBWastedManaCollect(event)

	if event == "UNIT_POWER" then
	
		if UnitPower("player") > MMBregmanapool then
			MMBPower = UnitPower("player")
        elseif UnitPower("player") < MMBregmanapool then
			MMBPower = 0 
 		end
		
	elseif event == "UNIT_MAXPOWER" then
		
		MMBPowerMax = UnitPowerMax("player")
		
		if MMBPowerMax < MMBPower then
			MMBWastedMana = MMBPower - MMBPowerMax
			print(format("|cffff00ff -- You just wasted |cffffffff%.0f |cffff00ffmana --", MMBWastedMana))
			MMBTotalWastedMana = MMBTotalWastedMana + MMBWastedMana
			MMBWastedMana = 0
			MMBPower = 0
		end
		
	end
end
	
MMBcurrentbuff = {}
	
MMBbufflist = {
	
	{"Power Torrent", 74241, 7500},
	{"Volcanic Power", 79476, 18000},
	{"Volcanic Destruction", 89091, 24000},
	{"Lightweave", 75170, 8700},
	{"Lightweave", 55367, 4425},
	{"Synapse Springs", 96230, 7200},
	{"Mark of the firelord", 97007, 19155}
}
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MageManaBar_OnEvent(self, event, ...)

	if (event == "PLAYER_LOGIN") then
		
		MMBNewSettingsCheck()

		if MMBNewSettings > 0 then
			print(format(" -- %.0f new settings have been loaded for MageManaBar, check option panel to see the new features. --", MMBNewSettings))
		end
		
		MageManaBarWarningBar:SetMinMaxValues(0,2)
		
		CreateFrame("Cooldown","MMBevocationCooldown",MMBevocationFrame)
		MMBevocationCooldown:SetAllPoints(MMBevocationFrame)
		MMBevocationCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBevocationgradCooldown",MMBevocationgradFrame)
		MMBevocationgradCooldown:SetAllPoints(MMBevocationgradFrame)
		CreateFrame("Cooldown","MMBmanaGemCooldown",MMBmanaGemFrame)
		MMBmanaGemCooldown:SetAllPoints(MMBmanaGemFrame)
		MMBmanaGemCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBmanaGemgradCooldown",MMBmanaGemgradFrame)
		MMBmanaGemgradCooldown:SetAllPoints(MMBmanaGemgradFrame)
		CreateFrame("Cooldown","MMBmageArmorgradCooldown",MMBmageArmorgradFrame)
		MMBmageArmorgradCooldown:SetAllPoints(MMBmageArmorgradFrame)
		CreateFrame("Cooldown","MMBmageArmorCooldown",MMBmageArmorFrame)
		MMBmageArmorCooldown:SetAllPoints(MMBmageArmorFrame)
		MMBmageArmorCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBArcaneTorrentCooldown",MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown:SetAllPoints(MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBArcaneTorrentgradCooldown",MMBArcaneTorrentgradFrame)
		MMBArcaneTorrentgradCooldown:SetAllPoints(MMBArcaneTorrentgradFrame)
		CreateFrame("Cooldown","MMBOrbCooldown",MMBOrbFrame)
		MMBOrbCooldown:SetAllPoints(MMBOrbFrame)
		MMBOrbCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBOrbgradCooldown",MMBOrbgradFrame)
		MMBOrbgradCooldown:SetAllPoints(MMBOrbgradFrame)
		
		if (select(2, UnitRace("player")) == "BloodElf") then
			(MMBSettings[11])[2] = true
		else (MMBSettings[11])[2] = false
		end 
		
		MMBFrameResize()
		
	elseif (event == "UNIT_POWER") then
			
		local unit, powertype = select(1, ...)
	
		if (unit == "player") then
		
			MMBmagearmorupdate()
			MMBManabarUpdate()

			if (MMBSettings[15])[2] == true then
				MMBmanabarcolorchange(event)
			end
			
			if (MMBSettings[1])[17] == true then
				MMBWastedManaCollect(event)
			end
			
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then

			MMBmagearmorupdate()
			MMBManabarUpdate()
	
	elseif (event == "UNIT_MAXPOWER") then
	
		local unit, powertype = select(1, ...)
		
		if (unit == "player") then
		
			MMBManabarMaxPool()
			MMBmagearmorupdate()
			if (MMBSettings[1])[17] == true then
				MMBWastedManaCollect(event)
			end
			
		end
		
	elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then

		if (select(4,GetBuildInfo()) >= 40200)
			then timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
		else timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
		end
			
			if (sourceName == UnitName("player")) then
				
				if (event == "SPELL_PERIODIC_ENERGIZE") and (spellId == 6117) then -- mage armor cooldown
					MMBmageArmorgradCooldown:SetCooldown(0,0)
					MMBmageArmorCooldown:SetCooldown(GetTime(),5)
                end
			end
		
	elseif (event == "PLAYER_REGEN_DISABLED") or (event == "PLAYER_REGEN_ENABLED") or (event == "PLAYER_TALENT_UPDATE") then
	
		MMBAutohide()
		MMBmageArmorSpec()
		
	elseif (event == "UNIT_HEALTH") or (event == "UNIT_MAXHEALTH") then
	
		local unit = select(1, ...)
		
		if unit == "player" then
			MMBhealthUpdate()
		end
		
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then
	
		if MMBTotalWastedMana ~= 0 and (MMBSettings[1])[17] == true then
			if MMBTotalWastedMana > 1000 then
				print(format("|cffff00ff -- You wasted |cffffffff%.1fk |cffff00ffmana during this fight --", MMBTotalWastedMana/1000))
			else print(format("|cffff00ff -- You wasted |cffffffff%.0f |cffff00ffmana during this fight --", MMBTotalWastedMana))
			end
		end
		MMBTotalWastedMana = 0
		
    elseif (event == "PLAYER_REGEN_DISABLED") then
		MMBTotalWastedMana = 0
	end
end

-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MageManaBar_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	self.TimeSinceLastUpdate1sec = (self.TimeSinceLastUpdate1sec or 0) + elapsed;
	
		if (self.TimeSinceLastUpdate > MageManaBar_UpdateInterval) then
		
			MMBmanaInfoUpdate()
			MMBwarning()
			
			if ((MMBSettings[14])[2] == true) then
				MMBSpellcastManaCost()
			end
			
			if (MMBInfoCoordsTarget ~= nil) then
				MMBInfoCoords(_G[MMBInfoCoordsTarget[1]],MMBInfoCoordsTarget[2])
			end
			
			MMBSpellTimer("manaGem",5405)
			MMBSpellTimer("evocation",12051)
			MMBSpellTimer("ArcaneTorrent",28730)
			MMBSpellTimer("Orb",82731)
						
			self.TimeSinceLastUpdate = 0
			
		end

		if (self.TimeSinceLastUpdate1sec > MageManaBar1sec_UpdateInterval) then
							
			------------------------------------- Mage Armor stuff
			MMBMageArmorType()
			
			self.TimeSinceLastUpdate1sec = 0
		
		end
end


SLASH_MMBCONFIG1 = "/magemanabar"

SlashCmdList["MMBCONFIG"] = function(msg)

	if msg == "" or  msg == "help" or  msg == "?" or msg == "config" then
		 InterfaceOptionsFrame_OpenToCategory("MageManaBar")
	else
		 InterfaceOptionsFrame_OpenToCategory("MageManaBar")
	end

end